/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	!function() {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/publicPath */
/******/ 	!function() {
/******/ 		__webpack_require__.p = "";
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": function() { return /* binding */ entry_lib; },
  install: function() { return /* reexport */ install; }
});

;// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/setPublicPath.js
/* eslint-disable no-var */
// This file is imported into lib/wc client bundles.

if (typeof window !== 'undefined') {
  var currentScript = window.document.currentScript
  if (false) { var getCurrentScript; }

  var src = currentScript && currentScript.src.match(/(.+\/)[^/]+\.js(\?.*)?$/)
  if (src) {
    __webpack_require__.p = src[1] // eslint-disable-line
  }
}

// Indicate to webpack that this file can be concatenated
/* harmony default export */ var setPublicPath = (null);

;// CONCATENATED MODULE: ./node_modules/thread-loader/dist/cjs.js!./node_modules/babel-loader/lib/index.js??clonedRuleSet-40.use[1]!./node_modules/@vue/vue-loader-v15/lib/loaders/templateLoader.js??ruleSet[1].rules[3]!./node_modules/@vue/vue-loader-v15/lib/index.js??vue-loader-options!./src/components/ImageHighlighter.vue?vue&type=template&id=6c814f55&scoped=true&
var render = function render() {
  var _vm = this,
    _c = _vm._self._c;
  return _c('div', [_c('canvas', {
    ref: "highlighter-canvas",
    staticClass: "highlighter-canvas",
    attrs: {
      "id": "highlighter-canvas"
    }
  }, [_vm._t("default")], 2), _c('div', {
    staticClass: "pointer"
  })]);
};
var staticRenderFns = [];

;// CONCATENATED MODULE: ./node_modules/thread-loader/dist/cjs.js!./node_modules/babel-loader/lib/index.js??clonedRuleSet-40.use[1]!./node_modules/@vue/vue-loader-v15/lib/index.js??vue-loader-options!./src/components/ImageHighlighter.vue?vue&type=script&lang=js&
/* harmony default export */ var ImageHighlightervue_type_script_lang_js_ = ({
  name: "ImageHighlighter",
  props: {
    position: {
      type: String,
      default: "top",
      validator(position) {
        return ["top", "bottom"].indexOf(position) > -1;
      }
    },
    styles: {
      type: Object,
      default: () => ({})
    }
  },
  data() {
    return {
      drawing: false,
      paintSize: 4,
      drawMargin: {
        left: 0,
        right: 0,
        top: 0,
        bottom: 0
      }
    };
  },
  methods: {
    drawImageScaled(img, ctx) {
      var canvas = ctx.canvas;
      var hRatio = canvas.width / img.width;
      var vRatio = canvas.height / img.height;
      var ratio = Math.min(hRatio, vRatio);
      var centerShift_x = (canvas.width - img.width * ratio) / 2;
      var centerShift_y = (canvas.height - img.height * ratio) / 2;
      ctx.clearRect(0, 0, canvas.width, canvas.height);
      let imgWidth = img.width * ratio;
      let imgHeight = img.height * ratio;
      let leftMargin = (canvas.width - imgWidth) / 2;
      let rightMargin = leftMargin + imgWidth;
      let topMargin = (canvas.height - imgHeight) / 2;
      let bottomMargin = topMargin + imgHeight;
      let halfPaintSize = this.paintSize / 2;
      this.drawMargin.left = leftMargin + halfPaintSize;
      this.drawMargin.right = rightMargin - halfPaintSize;
      this.drawMargin.top = topMargin + halfPaintSize;
      this.drawMargin.bottom = bottomMargin;
      ctx.drawImage(img, 0, 0, img.width, img.height, centerShift_x, centerShift_y, img.width * ratio, img.height * ratio);
    }
  },
  mounted() {
    let strDataURI = "https://upload.wikimedia.org/wikipedia/commons/b/b6/Image_created_with_a_mobile_phone.png";
    const canvas = this.$refs["highlighter-canvas"];
    let ctx = canvas.getContext("2d");
    var img = new Image();
    img.onload = this.drawImageScaled.bind(null, img, ctx);
    img.src = strDataURI;
    canvas.onmousedown = () => {
      //dragOffset.x = e.x - mainLayer.trans.x;
      //dragOffset.y = e.y - mainLayer.trans.y;

      this.mouseIsDown = true;
    };
    canvas.onmouseup = () => {
      //if (this.mouseIsDown) mouseClick(e);
      this.mouseIsDown = false;
    };
    const offsetLeft = canvas.offsetLeft;
    const offsetTop = canvas.offsetTop;
    const clientWidth = canvas.clientWidth;
    const clientHeight = canvas.clientHeight;
    const canvasWidth = canvas.width;
    const canvasHeight = canvas.height;
    canvas.onmousemove = e => {
      if (!this.mouseIsDown) return;
      let mousePosX = e.clientX - offsetLeft - this.paintSize / 2;
      let calculatedX = mousePosX * canvasWidth / clientWidth;
      let mousePosY = e.clientY - offsetTop - this.paintSize / 2;
      let calculatedY = mousePosY * canvasHeight / clientHeight;
      if (calculatedX < this.drawMargin.left || calculatedX > this.drawMargin.right) {
        return;
      }
      if (calculatedY < this.drawMargin.top || calculatedY > this.drawMargin.bottom) {
        return;
      }
      ctx.fillStyle = "red";
      ctx.fillRect(calculatedX, calculatedY, this.paintSize, this.paintSize);
      return false;
    };
  }
});
;// CONCATENATED MODULE: ./src/components/ImageHighlighter.vue?vue&type=script&lang=js&
 /* harmony default export */ var components_ImageHighlightervue_type_script_lang_js_ = (ImageHighlightervue_type_script_lang_js_); 
;// CONCATENATED MODULE: ./node_modules/mini-css-extract-plugin/dist/loader.js??clonedRuleSet-12.use[0]!./node_modules/css-loader/dist/cjs.js??clonedRuleSet-12.use[1]!./node_modules/@vue/vue-loader-v15/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/dist/cjs.js??clonedRuleSet-12.use[2]!./node_modules/@vue/vue-loader-v15/lib/index.js??vue-loader-options!./src/components/ImageHighlighter.vue?vue&type=style&index=0&id=6c814f55&prod&scoped=true&lang=css&
// extracted by mini-css-extract-plugin

;// CONCATENATED MODULE: ./src/components/ImageHighlighter.vue?vue&type=style&index=0&id=6c814f55&prod&scoped=true&lang=css&

;// CONCATENATED MODULE: ./node_modules/@vue/vue-loader-v15/lib/runtime/componentNormalizer.js
/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file (except for modules).
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

function normalizeComponent(
  scriptExports,
  render,
  staticRenderFns,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier /* server only */,
  shadowMode /* vue-cli only */
) {
  // Vue.extend constructor export interop
  var options =
    typeof scriptExports === 'function' ? scriptExports.options : scriptExports

  // render functions
  if (render) {
    options.render = render
    options.staticRenderFns = staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = 'data-v-' + scopeId
  }

  var hook
  if (moduleIdentifier) {
    // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = shadowMode
      ? function () {
          injectStyles.call(
            this,
            (options.functional ? this.parent : this).$root.$options.shadowRoot
          )
        }
      : injectStyles
  }

  if (hook) {
    if (options.functional) {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functional component in vue file
      var originalRender = options.render
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context)
        return originalRender(h, context)
      }
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook]
    }
  }

  return {
    exports: scriptExports,
    options: options
  }
}

;// CONCATENATED MODULE: ./src/components/ImageHighlighter.vue



;


/* normalize component */

var component = normalizeComponent(
  components_ImageHighlightervue_type_script_lang_js_,
  render,
  staticRenderFns,
  false,
  null,
  "6c814f55",
  null
  
)

/* harmony default export */ var ImageHighlighter = (component.exports);
;// CONCATENATED MODULE: ./src/components/index.js

function install(Vue) {
  if (install.installed) return;
  install.installed = true;
  Vue.component("MyComponent", ImageHighlighter);
}
// Create module definition for Vue.use()
const components_plugin = {
  install
};

// Auto-install when vue is found (eg. in browser via <script> tag)
let GlobalVue = null;
if (typeof window !== "undefined") {
  GlobalVue = window.Vue;
} else if (typeof __webpack_require__.g !== "undefined") {
  GlobalVue = __webpack_require__.g.Vue;
}
if (GlobalVue) {
  GlobalVue.use(components_plugin);
}

// To allow use as module (npm/webpack/etc.) export component
/* harmony default export */ var components = (ImageHighlighter);

/*
Object.keys(Components).forEach((name) => {
  Vue.component(name, Components[name]);
});
*/
;// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/entry-lib.js


/* harmony default export */ var entry_lib = (components);


module.exports = __webpack_exports__;
/******/ })()
;
//# sourceMappingURL=vue-image-highlighter.common.js.map